<?php 
/*
 /////////////////// DISCLAIMER ///////////////////////////
 THIS EXAMPLE CODE IS PROVIDED TO YOU ONLY ON AN "AS IS"
 BASIS WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION
 ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT,
 MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 PAYPAL MAKES NO WARRANTY THAT THE SOFTWARE OR
 DOCUMENTATION WILL BE ERROR-FREE. IN NO EVENT SHALL THE
 COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ////////////////////////////////////////////////////////////
 */

//Include the PHP file to generate client token
require_once('getClientToken.php');
//$clientToken = Braintree_ClientToken::generate();
?>
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8">
    <title>BT Hosted Fields</title>
    <link rel="stylesheet" type="text/css" href="bt_css.css">
      <!--Let browser know website is optimized for mobile-->
      <meta name="viewport" content="width=device-width, initial-scale=1.0"/>  
  </head>
<body>
	<div>
	  		<div>
	      	  <img width="250" src="https://www.technobezz.com/files/uploads/2014/11/Advantages-Of-Android-Phone.jpg">
	      	  <textarea style="height:400px; width:400px;"id="textarea1"  disabled>Google's new Pixel 2 gives you sleek and solid hardware, all of the requisite specs inside and runs simple and intuitive software at a breakneck pace. The hardware surely isn't flashy, but it's beautiful and efficient, and it's now IP67 water-resistant like we expect. The software features and Google's apps aren't numerous, but they're delightfully useful without being bothersome. And with three years of guaranteed updates, you don't have to worry about the future.The Pixel 2 has once again set the standard for Android cameras as well, with Google's 'HDR+' processing buoyed by new camera hardware and even better processing. Photos are accurate with just a little extra punch of color, and can manage tough scenes with little issue. And with Android 8.1, the Pixel Visual Core chipset enables dramatically better photos in third-party apps. </textarea>
	  		</div>
	  	<br><br>
	        <div>
	          <input disabled value="200" id="disabled" type="text">
	          <label for="disabled">Price</label>
	        </div>  
		<br><br>
		
			<form id="cardForm">
			  <div class="panel">
			    <header class="panel__header">
			      <h1>Card Payment</h1>
			    </header>
			    <div class="panel__content">
			      <div class="textfield--float-label">
			        <!-- Begin hosted fields section -->
			        <label class="hosted-field--label" for="card-number"><span class="icon">
			         <svg xmlns="http://www.w3.org/2000/svg" width="20" height="20" viewBox="0 0 24 24"><path d="M0 0h24v24H0z" fill="none"/><path d="M20 4H4c-1.11 0-1.99.89-1.99 2L2 18c0 1.11.89 2 2 2h16c1.11 0 2-.89 2-2V6c0-1.11-.89-2-2-2zm0 14H4v-6h16v6zm0-10H4V6h16v2z"/></svg></span> Card Number 
			        </label>
			        <div id="card-number" class="hosted-field"></div>
			        <!-- End hosted fields section -->
			      </div>
			      <div class="textfield--float-label">
			        <!-- Begin hosted fields section -->
			        <label class="hosted-field--label" for="expiration-date">
			           <span class="icon">
			          <svg xmlns="http://www.w3.org/2000/svg" width="20" height="20" viewBox="0 0 24 24"><path d="M9 11H7v2h2v-2zm4 0h-2v2h2v-2zm4 0h-2v2h2v-2zm2-7h-1V2h-2v2H8V2H6v2H5c-1.11 0-1.99.9-1.99 2L3 20c0 1.1.89 2 2 2h14c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm0 16H5V9h14v11z"/></svg>
			         </span>
			          Expiration Date</label>
			        <div id="expiration-date" class="hosted-field"></div>
			        <!-- End hosted fields section -->
			      </div>
			      <div class="textfield--float-label">
			        <!-- Begin hosted fields section -->
			        <label class="hosted-field--label" for="cvv">
			          <span class="icon">
			            <svg xmlns="http://www.w3.org/2000/svg" width="20" height="20" viewBox="0 0 24 24"><path d="M18 8h-1V6c0-2.76-2.24-5-5-5S7 3.24 7 6v2H6c-1.1 0-2 .9-2 2v10c0 1.1.9 2 2 2h12c1.1 0 2-.9 2-2V10c0-1.1-.9-2-2-2zm-6 9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2zm3.1-9H8.9V6c0-1.71 1.39-3.1 3.1-3.1 1.71 0 3.1 1.39 3.1 3.1v2z"/></svg>
			            </span>
			            CVV</label>
			        <div id="cvv" class="hosted-field"></div>
			        <!-- End hosted fields section -->
			      </div>
			   
			         <!-- End hosted fields section -->
			      </div>
			    </div>
			    <footer class="panel__footer">
			      
			     <button class="pay-button">Pay</button>
			    </footer>
			    
			</form>
	</div>

    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
    <script src="https://js.braintreegateway.com/web/3.47.0/js/client.min.js"></script>
    <script src="https://js.braintreegateway.com/web/3.47.0/js/hosted-fields.min.js"></script>
	<!-- Load the 3D Secure component. -->
	<script src="https://js.braintreegateway.com/web/3.47.0/js/three-d-secure.min.js"></script>
   
    <script>

    //Checkout using cards
    
    var nonce;
	var vars;
	var threeDSecure;
	var my3DSContainer = document.createElement('div');
	var bin;
	
    braintree.client.create({
    	  authorization: '<?= $clientToken?>'
    	}, function(err, clientInstance) {
    	  if (err) {
    	    console.error(err);
    	    return;
    	  }

    	  braintree.threeDSecure.create({
        	  	version: '2',
    		    client: clientInstance
    		  }, function (threeDSecureErr, threeDSecureInstance) {
    		    if (threeDSecureErr) {
    		      // Handle error in 3D Secure component creation
    		      return;
    		    }

    		    threeDSecure = threeDSecureInstance;

    		    
    	    		    
    		  });

    	  

    	  braintree.hostedFields.create({
    	    client: clientInstance,
    	    styles: {
    	      'input': {
    	        'font-size': '16px',
    	        'font-family': 'roboto, verdana, sans-serif',
    	        'font-weight': 'lighter',
    	        'color': 'black'
    	      },
    	      ':focus': {
    	        'color': 'black'
    	      },
    	      '.valid': {
    	        'color': 'green'
    	      },
    	      '.invalid': {
    	        'color': 'red'
    	      }
    	    },
    	    fields: {
    	      number: {
    	        selector: '#card-number',
    	        placeholder: '1111 1111 1111 1111'
    	      },
    	      cvv: {
    	        selector: '#cvv',
    	        placeholder: '111'
    	      },
    	      expirationDate: {
    	        selector: '#expiration-date',
    	        placeholder: 'MM/YY'
    	      }
    	    }
    	  },
			
    	   function(err, hostedFieldsInstance) {
    	    if (err) {
    	      console.error(err);
    	      return;
    	    }

    	    $('#cardForm').submit(function (event) {
    	      event.preventDefault();

    	      hostedFieldsInstance.tokenize(function (err, payload) {
    	        if (err) {
    	          console.error(err);
    	          return;
    	        }


    	       //Get nonce and bin data
    	        nonce = payload.nonce;
    	        bin = payload.details.bin;
    	        //console.log("BIN: " + bin);
    	        

    	        threeDSecure.verifyCard({
    	    		  amount: '500.00',
    	    		  nonce: nonce,
    	    		  bin: bin,
    	    		  email: "usersemail@email.com",
    	    		  billingAddress: {
    	    			    givenName: 'Brian',
    	    			    surname: 'McManus',
    	    			    phoneNumber: '07712345678',
    	    			    streetAddress: '10 Downing Street',
    	    			    extendedAddress: '', // When available
    	    			    locality: 'London',
    	    			    region: 'London',
    	    			    postalCode: 'SW1A 2AA',
    	    			    countryCodeAlpha2: 'GB'
    	    			  },
    	    			  additionalInformation: {
    	    			    workPhoneNumber: '07712345678',
    	    			    shippingGivenName: 'Brian',
    	    			    shippingSurname: 'McManus',
    	    			    shippingPhone: '07712345678',
    	    			    shippingAddress: {
    	    			      streetAddress: '10 Downing Street',
    	    			      extendedAddress: '', // When available
    	    			      locality: 'London',
    	    			      region: 'London',
    	    			      postalCode: 'SW1A 2AA',
    	    			      countryCodeAlpha2: 'GB'
    	    			    }
    	    			  },
    	    		  addFrame: function (err, iframe) {
    	    		    // Set up your UI and add the iframe.
    	    		    my3DSContainer.appendChild(iframe);
    	    		    document.body.appendChild(my3DSContainer);
    	    		  },
    	    		  removeFrame: function () {
    	    		    // Remove UI that you added in addFrame.
    	    		    document.body.removeChild(my3DSContainer);
    	    		  }
    	    		}, function (err, response) {
    	    		  // Send response.nonce to use in your transaction
    		    		  var liabilityShifted = response.liabilityShifted; // true || false

    		    		  console.log(response);
    		    		  var vars = {'payment_method_nonce' : response.nonce};

    		    		  if (response.liabilityShifted) {
    		    			    // Liablity has shifted
    		    			   $.ajax({ 
                                  	type: "POST",
                                      cache: false,
                                	    url: "doPayment.php",
                                	    dataType: "text",
                                	    data: vars
                                	}).done(function (data) {
                                    	
                                    	vars = JSON.parse(data);
                                    	if(vars['success'] == 1)
                                    	{
                                        	alert("Success");
                                        	hostedFieldsInstance.clear('number');
              	    		    			hostedFieldsInstance.clear('cvv');
              	    		    			hostedFieldsInstance.clear('expirationDate');
                                    	}
                                    	else
                                    	{
                                        	alert("Failed");
                                        	hostedFieldsInstance.clear('number');
              	    		    			hostedFieldsInstance.clear('cvv');
              	    		    			hostedFieldsInstance.clear('expirationDate');
                                    	}
                                    	console.log("Nonce return data: " + vars);
                                	}).fail(function (jqXHR, textStatus) {
                                	    console.log("failed to get nonce return data");
                                	});
    		    		  
                                	
    		    			  } else if (response.liabilityShiftPossible) {
    		    			    // Liablity may still be shifted
    		    			    // Decide if you want to submit the nonce
    		    				  hostedFieldsInstance.clear('number');
  	    		    			hostedFieldsInstance.clear('cvv');
  	    		    			hostedFieldsInstance.clear('expirationDate');
  	    		    			alert("There was an issue with this transaciton, Payment Failed");
    		    			  } else {
		    				    hostedFieldsInstance.clear('number');
	    		    			hostedFieldsInstance.clear('cvv');
	    		    			hostedFieldsInstance.clear('expirationDate');
	    		    			alert("Payment Failed Please make sure all information is correct");
    		    			  }
    		    			
    		    		  });
    	    		});


    	        // This is where you would submit payload.nonce to your server
    	        //alert('Submit your nonce to your server here!');
    	      });
    	    });
    		
    	});
    	

    </script>
    
    

  </body>
</html>